[1/2] Autogenerate gdb/syscalls/linux-defaults.xml.in (groups) from strace sources

Message ID 20230224232650.4031472-2-pedro@palves.net
State New
Headers
Series Autogenerate gdb/syscalls/linux-defaults.xml.in (syscall groups) from strace sources |

Commit Message

Pedro Alves Feb. 24, 2023, 11:26 p.m. UTC
  I noticed that "catch syscall group:process" doesn't catch clone3,
while it does catch clone.

The catch syscall group information is recorded in the
gdb/syscalls/linux-defaults.xml.in file, which says:

  <!-- The group field information was based on strace.  -->

So I looked at the strace sources, to confirm that clone3 is in fact
recorded in the "process" group there too, and to check what other
syscalls might be missing groups.

After some digging, I found that strace records the group info in C
arrays, with entries like:
...
[ 61] = { 4,	TP,		SEN(wait4),			"wait4"			},
[ 62] = { 2,	TS|TP,		SEN(kill),			"kill"			},
[ 63] = { 1,	0,		SEN(uname),			"uname"			},
...

You can see the current master's table for Linux x86-64 here:

  https://github.com/strace/strace/blob/e88e5e9ae6da68f22d15f9be3193b1412ac9aa02/src/linux/x86_64/syscallent.h

The column with TS|TP above is what defines each syscall's groups.  So
I wrote a script that extracts this information and generates
linux-defaults.xml.in.

Change-Id: I679d59d42fb2a914bf7a99e4c558e9696e5adff1
---
 gdb/syscalls/update-linux-defaults.sh | 95 +++++++++++++++++++++++++++
 1 file changed, 95 insertions(+)
 create mode 100755 gdb/syscalls/update-linux-defaults.sh
  

Comments

Simon Marchi Feb. 25, 2023, 3 a.m. UTC | #1
On 2/24/23 18:26, Pedro Alves wrote:
> I noticed that "catch syscall group:process" doesn't catch clone3,
> while it does catch clone.
> 
> The catch syscall group information is recorded in the
> gdb/syscalls/linux-defaults.xml.in file, which says:
> 
>   <!-- The group field information was based on strace.  -->
> 
> So I looked at the strace sources, to confirm that clone3 is in fact
> recorded in the "process" group there too, and to check what other
> syscalls might be missing groups.
> 
> After some digging, I found that strace records the group info in C
> arrays, with entries like:
> ...
> [ 61] = { 4,	TP,		SEN(wait4),			"wait4"			},
> [ 62] = { 2,	TS|TP,		SEN(kill),			"kill"			},
> [ 63] = { 1,	0,		SEN(uname),			"uname"			},
> ...
> 
> You can see the current master's table for Linux x86-64 here:
> 
>   https://github.com/strace/strace/blob/e88e5e9ae6da68f22d15f9be3193b1412ac9aa02/src/linux/x86_64/syscallent.h
> 
> The column with TS|TP above is what defines each syscall's groups.  So
> I wrote a script that extracts this information and generates
> linux-defaults.xml.in.

Thanks, that LGTM.

I think the filename passed around is not actually used, so you can do:

---

diff --git a/gdb/syscalls/update-linux-defaults.sh b/gdb/syscalls/update-linux-defaults.sh
index 2c001aa3b8a9..bf74f1e321a8 100755
--- a/gdb/syscalls/update-linux-defaults.sh
+++ b/gdb/syscalls/update-linux-defaults.sh
@@ -35,8 +35,6 @@ fi
 
 pre ()
 {
-    f="$1"
-
     year=$(date +%Y)
 
     cat <<EOF
@@ -61,9 +59,7 @@ post ()
 
 generate ()
 {
-    f="$1"
-
-    pre "$f"
+    pre
 
     grep -rn -E "T[A-Z][,|]" "$d/src/linux/" \
 	| sed -e 's/\(T[A-Z][,|].*\)/\x03&/' -e 's/.*\x03//' \
@@ -92,4 +88,4 @@ generate ()
 f=linux-defaults.xml.in
 
 echo "Generating $f"
-generate "$t" > "$f"
+generate > "$f"

---

I was tipped off by this shellcheck warning:

In update-linux-defaults.sh line 95:
generate "$t" > "$f"
          ^-- SC2154 (warning): t is referenced but not assigned.

Simon
  
Pedro Alves Feb. 27, 2023, 3:04 p.m. UTC | #2
On 2023-02-25 3:00 a.m., Simon Marchi wrote:
> 
> 
> On 2/24/23 18:26, Pedro Alves wrote:
>> I noticed that "catch syscall group:process" doesn't catch clone3,
>> while it does catch clone.
>>
>> The catch syscall group information is recorded in the
>> gdb/syscalls/linux-defaults.xml.in file, which says:
>>
>>   <!-- The group field information was based on strace.  -->
>>
>> So I looked at the strace sources, to confirm that clone3 is in fact
>> recorded in the "process" group there too, and to check what other
>> syscalls might be missing groups.
>>
>> After some digging, I found that strace records the group info in C
>> arrays, with entries like:
>> ...
>> [ 61] = { 4,	TP,		SEN(wait4),			"wait4"			},
>> [ 62] = { 2,	TS|TP,		SEN(kill),			"kill"			},
>> [ 63] = { 1,	0,		SEN(uname),			"uname"			},
>> ...
>>
>> You can see the current master's table for Linux x86-64 here:
>>
>>   https://github.com/strace/strace/blob/e88e5e9ae6da68f22d15f9be3193b1412ac9aa02/src/linux/x86_64/syscallent.h
>>
>> The column with TS|TP above is what defines each syscall's groups.  So
>> I wrote a script that extracts this information and generates
>> linux-defaults.xml.in.
> 
> Thanks, that LGTM.
> 
> I think the filename passed around is not actually used, so you can do:
> 

Thanks, I've done that, and pushed the series.

> 
> I was tipped off by this shellcheck warning:
> 
> In update-linux-defaults.sh line 95:
> generate "$t" > "$f"
>           ^-- SC2154 (warning): t is referenced but not assigned.
> 

Thanks for that.  For some reason I forgot to run it.
  

Patch

diff --git a/gdb/syscalls/update-linux-defaults.sh b/gdb/syscalls/update-linux-defaults.sh
new file mode 100755
index 00000000000..2c001aa3b8a
--- /dev/null
+++ b/gdb/syscalls/update-linux-defaults.sh
@@ -0,0 +1,95 @@ 
+#!/bin/sh
+
+# Copyright (C) 2023 Free Software Foundation, Inc.
+#
+# This file is part of GDB.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Used to generate linux-defaults.xml.in, like so:
+# $ ./update-linux-defaults.sh ~/strace.git
+
+if [ $# -lt 1 ]; then
+    echo "dir argument needed"
+    exit 1
+fi
+
+d="$1"
+shift
+
+if [ ! -d "$d" ]; then
+    echo "cannot find $d"
+    exit 1
+fi
+
+pre ()
+{
+    f="$1"
+
+    year=$(date +%Y)
+
+    cat <<EOF
+<?xml version="1.0"?>
+<!-- Copyright (C) 2009-$year Free Software Foundation, Inc.
+
+     Copying and distribution of this file, with or without modification,
+     are permitted in any medium without royalty provided the copyright
+     notice and this notice are preserved.  -->
+
+<!-- This file was generated using the sources from strace.  -->
+EOF
+
+    echo '<syscalls_defaults>'
+}
+
+
+post ()
+{
+    echo '</syscalls_defaults>'
+}
+
+generate ()
+{
+    f="$1"
+
+    pre "$f"
+
+    grep -rn -E "T[A-Z][,|]" "$d/src/linux/" \
+	| sed -e 's/\(T[A-Z][,|].*\)/\x03&/' -e 's/.*\x03//' \
+	      -e 's/,[ \t]*SEN[ \t]*(/, SEN(/g' \
+	| grep ", SEN(" \
+	| sed -e 's/\(.*\"\).*/\1/g' \
+	      -e 's/#64\"/\"/g' \
+	| awk '{print $3 " " $1}' \
+	| sort -u \
+	| sed -e 's/|/,/g' \
+	      -e 's/TD,/descriptor,/g' \
+	      -e 's/TF,/file,/g' \
+	      -e 's/TI,/ipc,/g' \
+	      -e 's/TM,/memory,/g' \
+	      -e 's/TN,/network,/g' \
+	      -e 's/TP,/process,/g' \
+	      -e 's/TS,/signal,/g' \
+	      -e 's/[A-Z]\+,//g' \
+	| grep -v '" $' \
+	| sed 's/,$//g' \
+	| awk "{printf \"  <syscall name=%s groups=\\\"%s\\\"/>\n\", \$1, \$2}"
+
+    post
+}
+
+f=linux-defaults.xml.in
+
+echo "Generating $f"
+generate "$t" > "$f"